property movieList, curMovie, mNavigator, oldColor, miawWinRect, language

on birth me
  set mNavigator to "VAL"
  set movieList to ["Intro", "Choose", "Disclaim", "Main", "Credits"]
  set winL to the stageLeft + 69
  set winT to the stageTop + 64
  set miawWinRect to rect(winL, winT, winL + 512, winT + 384)
  set language to 1
  return me
end

on Color8Bits
  set oldColor to the colorDepth
  if oldColor <> 8 then
    set the colorDepth to 8
    delay(3 * 60)
  end if
end

on SetLanguage me, nr
  set language to nr
end

on GetLanguage me
  return language
end

on Dialog me
  openWindow(me, EMPTY, miawWinRect, 2)
end

on CleanUp me
  SoundStop(me)
  set the timeoutScript to EMPTY
end

on SoundStop me
  sound stop 1
  sound stop 2
  puppetSound(1, 0)
  puppetSound(2, 0)
  set the volume of sound 1 to 255
  set the volume of sound 2 to 255
end

on IsSoundOff me
  return 0
end

on TheStart me
  global gMoveOn
  CleanUp(me)
  KillAllWindows(me)
  set curMovie to 0
  set gMoveOn to 1
end

on TheEnd me
  CleanUp(me)
  quit()
end

on GoForward me
  set curMovie to curMovie + 1
  if curMovie > count(movieList) then
    TheEnd(me)
  else
    PlayMovie(me)
  end if
end

on GoBack me
  set curMovie to curMovie - 1
  if curMovie < 1 then
    TheStart(me)
  else
    PlayMovie(me)
  end if
end

on Navigator me
  if count(the windowList) = 0 then
    CleanUp(me)
    play movie mNavigator
  end if
end

on GoPlay me, nr
  set curMovie to nr
  KillAllWindows(me)
  updateStage()
  PlayMovie(me)
end

on PlayMovie me
  CleanUp(me)
  go(1, getAt(movieList, curMovie))
end

on openWindow me, movieName, theRect, type
  NewWindow(me, movieName, theRect, type)
  open(window movieName)
  moveToFront(window movieName)
end

on NewWindow me, movieName, theRect, type
  set theWindow to window movieName
  set the title of window "AlertBox" to EMPTY
  set the titleVisible of window movieName to 0
  set the rect of window movieName to theRect
  set the windowType of window movieName to type
end

on DisposeWindow me, theWindow
  if stringp(theWindow) then
    close(window theWindow)
    forget(window theWindow)
  end if
  updateStage()
end

on KillAllWindows me
  repeat with i = 1 to count(the windowList)
    close(getAt(the windowList, i))
    forget(getAt(the windowList, i))
  end repeat
end

on QuitApp me
  KillAllWindows(me)
  set the colorDepth to oldColor
  quit()
end
